﻿using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;

namespace WfcToJqGrid {
    [ServiceContract]
    public interface IWeatherDataService {
        [OperationContract,
         WebGet (RequestFormat = WebMessageFormat.Json,
                 ResponseFormat = WebMessageFormat.Json,
                 UriTemplate = "GetWeatherData?page={page}&rows={rows}" +
                               "&sidx={sortIndex}&sord={sortDirection}")]
        WeatherDataForJqGrid GetDataForjqGrid (int page, int rows,
                                               string sortIndex,
                                               SortDirection sortDirection);
    }

    [DataContract]
    public enum SortDirection {
        [EnumMember (Value = "asc")]
        Asc,
        [EnumMember (Value = "desc")]
        Desc
    }

    // jsonReader: { repeatitems: false }
    [DataContract]
    public class WeatherDataForJqGrid {
        [DataMember (Order=0, Name = "total")]
        public int Total { get; set; }          // total number of pages
        [DataMember (Order = 1, Name = "page")]
        public int Page { get; set; }           // current zero based page number
        [DataMember (Order = 2, Name = "records")]
        public int Records { get; set; }        // total number of records
        [DataMember (Order = 3, Name = "rows")]
        public IEnumerable<WeatherData> Rows { get; set; }
    }

    [DataContract]
    public class WeatherData {
        [DataMember (Order=0)]
        public int StationId { get; set; }
        [DataMember (Order = 1)]
        public string StationName { get; set; }
        [DataMember (Order = 2)]
        public DateTime Timestamp { get; set; }
        [DataMember (Order = 3, EmitDefaultValue = false)]
        public string MaxTemperature { get; set; }
        [DataMember (Order = 4, EmitDefaultValue = false)]
        public string MinTemperature { get; set; }
        [DataMember (Order = 5, EmitDefaultValue = false)]
        public string Precipitation { get; set; }
        [DataMember (Order = 6, EmitDefaultValue = false)]
        public string Snowfall { get; set; }
        [DataMember (Order = 7, EmitDefaultValue = false)]
        public string SnowDepth { get; set; }
    }
}
