﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel.Web;
using System.Net;

namespace WfcToJqGrid {
    public class WeatherDataService : IWeatherDataService {
        // we use very simple database model to simulate a real data
        private static IQueryable<WeatherData> _repository = new List<WeatherData> {
            new WeatherData { StationId = 50130, StationName = "ALAMOSA WSO AP",
                              Timestamp = new DateTime(1993,1,1,8,0,0)},
            new WeatherData { StationId = 50130, StationName = "ALAMOSA WSO AP",
                              Timestamp = new DateTime(1993,1,2,8,0,0)},
            new WeatherData { StationId = 50130, StationName = "ALAMOSA WSO AP",
                              Timestamp = new DateTime(1993,1,3,8,0,0)},
            new WeatherData { StationId = 50130, StationName = "ALAMOSA WSO AP",
                              Timestamp = new DateTime(1993,1,4,8,0,0)},
            new WeatherData { StationId = 50130, StationName = "ALAMOSA WSO AP",
                              Timestamp = new DateTime(1993,1,5,8,0,0)},
            new WeatherData { StationId = 50130, StationName = "ALAMOSA WSO AP",
                              Timestamp = new DateTime(1993,1,6,8,0,0)},
            new WeatherData { StationId = 50130, StationName = "ALAMOSA WSO AP",
                              Timestamp = new DateTime(1993,1,7,8,0,0)},
            new WeatherData { StationId = 50130, StationName = "ALAMOSA WSO AP",
                              Timestamp = new DateTime(1993,1,8,8,0,0)},
            new WeatherData { StationId = 50130, StationName = "ALAMOSA WSO AP",
                              Timestamp = new DateTime(1993,1,9,8,0,0)},
            new WeatherData { StationId = 50130, StationName = "ALAMOSA WSO AP",
                             Timestamp = new DateTime(1993,1,10,8,0,0)}
        }.AsQueryable ();

        public WeatherDataForJqGrid GetDataForjqGrid (int page, int rows,
                                                      string sortIndex,
                                                      SortDirection sortDirection) {
            int totalRecords = _repository.Count();
            
            // sorting of data
            IQueryable<WeatherData> orderdData = _repository;
            System.Reflection.PropertyInfo propertyInfo =
                typeof(WeatherData).GetProperty (sortIndex);
            if (propertyInfo != null) {
                orderdData = sortDirection == SortDirection.Desc ?
                    (from x in _repository
                     orderby propertyInfo.GetValue (x, null) descending
                     select x) :
                    (from x in _repository
                     orderby propertyInfo.GetValue (x, null)
                     select x);
            }
            
            // paging of the results
            IEnumerable<WeatherData> pagedData = orderdData
                .Skip ((page > 0? page - 1: 0) * rows)
                .Take (rows);

            // force revalidate data on the server on every request
            if (WebOperationContext.Current != null)
                WebOperationContext.Current.OutgoingResponse.Headers.Set (
                    HttpResponseHeader.CacheControl, "max-age=0");

            return new WeatherDataForJqGrid {
                Page = page,
                Records = totalRecords,
                Total = (totalRecords + rows - 1) / rows,
                Rows = pagedData
            };
        }
    }
}
